﻿/// @file server_setting.cpp
///
/// @brief MPPRINTER サーバーダイアログ制御
///
/// @date 2013.11.27 Create
///
/// @author Copyright (c) 2013, Sasaji. All rights reserved.
///
#include "server_setting.h"

// Attach Event
BEGIN_EVENT_TABLE(ServerBox, wxDialog)
	// event
	EVT_BUTTON(wxID_OK, ServerBox::OnButton)
END_EVENT_TABLE()

ServerBox::ServerBox(wxWindow* parent, wxWindowID id)
	: wxDialog(parent, id, _("Server settings"), wxDefaultPosition, wxDefaultSize, wxDEFAULT_DIALOG_STYLE)
{
	wxSizerFlags flags = wxSizerFlags().Expand().Border(wxALL, 4);

	wxBoxSizer *szrAll = new wxBoxSizer(wxVERTICAL);
	wxFlexGridSizer *gbox = new wxFlexGridSizer(1,3,0,0);

	spinDelay = new wxSpinCtrl(this, IDC_SPIN_DELAY);
	gbox->Add(new wxStaticText(this, wxID_ANY, _("Print Delay:")), flags);
	gbox->Add(spinDelay, flags);
	gbox->Add(new wxStaticText(this, wxID_ANY, _("ms.")), flags);

    szrAll->Add(gbox, flags);

	wxSizer *szrButtons = CreateButtonSizer(wxOK|wxCANCEL);
	szrAll->Add(szrButtons, flags);

	SetSizerAndFit(szrAll);
}

void ServerBox::init_dialog()
{
	spinDelay->SetRange(0, 10000);
	spinDelay->SetValue(mDelay);
}

void ServerBox::term_dialog()
{
	int i = spinDelay->GetValue();
	if (0 <= i && i <= 10000) mDelay = i;
}

void ServerBox::OnButton(wxCommandEvent& event)
{
	wxDialog::EndDialog(wxID_OK);
}

int ServerBox::ShowModal()
{
	// initialize
	init_dialog();
	int rc = wxDialog::ShowModal();
	if (rc == wxID_OK) {
		// update
		term_dialog();
	}
	return rc;
}

